with System;
with Gwindows.Windows;
with Gwindows.Gstrings;
with Gwindows.Utilities;
with Gwindows.Internal;
with Gwindows.Types; use Gwindows.Types;
with Ada.Unchecked_Deallocation;
with Ada.Text_Io; use Ada.Text_Io;
with System.Storage_Elements; use System.Storage_Elements;
with Ada.Strings.Fixed;
package body Gwindows.Common_Controls.Ex_LV is

   Lvm_First                    : constant := 16#1000#;
   Lvm_Setimagelist             : constant := Lvm_First + 3;
   Lvm_Setextendedlistviewstyle : constant := Lvm_First + 54;
   Lvm_Sortitems                : constant := Lvm_First + 48;
   Lvm_Finditema                : constant := Lvm_First + 13;
   Lvm_Finditemw                : constant := Lvm_First + 83;
   Lvm_Setitema                 : constant := Lvm_First + 6;
   Lvm_Setitemw                 : constant := Lvm_First + 76;
   Lvm_Settextcolor             : constant := Lvm_First + 36;
   LVM_SETTEXTBKCOLOR           : constant := LVM_FIRST + 38;
   LVM_SETBKCOLOR               : constant := LVM_FIRST + 1;
   Lvm_Redrawitems              : constant := Lvm_First + 21;
   Lvm_Getitema                 : constant := Lvm_First + 5;
   Lvm_Getitemw                 : constant := Lvm_First + 75;
   Lvm_Insertitema              : constant := Lvm_First + 7;
   Lvm_Insertitemw              : constant := Lvm_First + 77;
   LVM_SETCOLUMNWIDTH           : constant := LVM_FIRST + 30;
   LVM_GETCOLUMNWIDTH           : constant := LVM_FIRST + 29;
   LVM_GETSUBITEMRECT           : constant := LVM_FIRST + 56;
   LVM_GETHEADER                : constant := LVM_FIRST + 31;
   LVM_SETCOLUMNORDERARRAY      : constant := LVM_FIRST + 58;
   LVM_GETCOLUMNORDERARRAY      : constant := LVM_FIRST + 59;
   LVM_GETCOLUMNA               : constant := LVM_FIRST + 25;
   LVM_GETCOLUMNW               : constant := LVM_FIRST + 95;
   LVM_APPROXIMATEVIEWRECT      : constant := LVM_FIRST + 64;
   LVM_DELETECOLUMN             : constant := LVM_FIRST + 28;
   Lvs_Ex_Gridlines             : constant := 1;
   Lvs_Ex_Flatsb                : constant := 256;
   Lvs_Ex_Headerdragdrop        : constant := 16;
   Lvs_Ex_Fullrowselect         : constant := 32;
   Lvsil_Small                  : constant := 1;
   Lvfi_Param                   : constant := 1;
   Lvif_Param                   : constant := 16#0004#;
   Lvif_Text                    : constant := 16#0001#;
   Lvif_Image                   : constant := 16#0002#;
   LVCF_TEXT                    : constant := 16#0004#;
   Ccm_First                    : constant := 16#2000#;
   Ccm_Setversion               : constant := Ccm_First + 7;
   Cdds_Prepaint                : constant := 16#0001#;
   Cdds_Item                    : constant := 16#00010000#;
   Cdds_Itemprepaint            : constant := Cdds_Item + Cdds_Prepaint;
   Cdds_Subitem                 : constant := 16#00020000#;
   Cdrf_Notifyitemdraw          : constant := 16#00000020#;
   Cdrf_Notifysubitemdraw       : constant := 16#00000020#;
   Cdrf_Newfont                 : constant := 2;
   Cdrf_Dodefault               : constant := 0;
   Cdrf_Skipdefault             : constant := 4;
   HDM_FIRST                    : constant := 16#1200#;
   HDM_GETITEMA                 : constant := HDM_FIRST + 3;
   HDM_GETITEMW                 : constant := HDM_FIRST + 11;
   HDM_SETITEMA                 : constant := HDM_FIRST + 4;
   HDM_SETITEMW                 : constant := HDM_FIRST + 12;
   HDM_SETIMAGELIST             : constant := HDM_FIRST + 8;
   HDI_FORMAT                   : constant := 4;
   HDI_IMAGE                    : constant := 16#20#;
   HDI_TEXT                     : constant := 16#0002#;
   HDI_LPARAM                   : constant := 16#0008#;
   --   HDF_SORTUP                   : constant := 16#400#; available only >= Version 6 (XP)
   --   HDF_SORTDOWN                 : constant := 16#200#; available only >= Version 6 (XP)
   HDF_STRING                   : constant := 16#4000#;
   HDF_BITMAP_ON_RIGHT          : constant := 16#1000#;
   HDF_IMAGE                    : constant := 16#800#;
   HDF_OWNERDRAW                : constant := 16#8000#;

   type Lptstr is access all Gchar_C;

   type Nmlistview_Type is
      record
         Hdr       : Gwindows.Base.Notification;
         Iitem     : Interfaces.C.Int;
         Isubitem  : Interfaces.C.Int;
         Unewstate : Interfaces.C.Int;
         Uoldstate : Interfaces.C.Int;
         Uchanged  : Interfaces.C.Int;
         Point     : Gwindows.Types.Point_Type;
         Lparam    : System.address;
      end record;

   type Pointer_To_Nmlistview_Type is access all Nmlistview_Type;

   type Nmcustomdraw_Type is
      record
         Hdr         : Notification;
         Dwdrawstage : Interfaces.C.Long;
         Hdc         : Gwindows.Types.Handle;
         Rect        : Gwindows.Types.Rectangle_Type;
         Dwitemspec  : Interfaces.C.Long;
         Uitemstate  : Interfaces.C.Unsigned;
         Litemlparam : System.address;
      end record;

   type Pointer_To_Nmcustomdraw_Type is access all Nmcustomdraw_Type;

   type Nmlvcustomdraw_Type is
      record
         Nmcd      : Nmcustomdraw_Type;
         Clrtext   : Color_Type;
         Clrtextbk : Color_Type;
         Isubitem  : Interfaces.C.Int;
      end record;

   type Pointer_To_Nmlvcustomdraw_Type is access all Nmlvcustomdraw_Type;

   type Findinfo_Type is
      record
         Flags       : Interfaces.C.Unsigned := Lvfi_Param;
         Psz         : Lptstr                := null;
         Lparam      : System.address;
         Point       : Point_Type;
         Vkdirection : Interfaces.C.Unsigned := 0;
      end record;

   type Sort_Data_Type is
      record
         Control_Handle : Gwindows.Types.Handle;
         First_Column         : Integer;
         First_Is_Date : Boolean;
         First_Sort_Factor : Integer;
         second_Column         : Integer;
         second_Sort_Factor : Integer;
         Second_Is_Date : Boolean;
      end record;

   type Lvitem is
      record
         Mask      : Interfaces.C.Unsigned := 0;
         Item      : Integer               := 0;
         Subitem   : Integer               := 0;
         State     : Interfaces.C.Unsigned := 0;
         Statemask : Interfaces.C.Unsigned := 0;
         Text      : Lptstr                := null;
         Textmax   : Integer               := 0;
         Image     : Integer;
         Lparam    : System.Address;
         Indent    : Integer;
      end record;

   type Hditem is
      record
         Mask      : Interfaces.C.Unsigned := 0;
         Cxy       : Interfaces.C.Int      := 0;
         pszText   : Lptstr                := null;
         HBitmap   : Interfaces.C.Long     := 0;
         CchTextMax: Interfaces.C.Int      := 0;
         Fmt       : Interfaces.C.Int      := 0;
         Lparam    : System.Address;
         IImage    : Interfaces.C.Int      := 0;
         IOrdegr    : Interfaces.C.Int      := 0;
         Typ       : Interfaces.C.Unsigned := 0;
         PvFilter  : System.Address        ;
      end record;

   type Hditem_Pointer is access all Hditem;

   type Lvcolumn is
      record
         Mask    : Interfaces.C.Unsigned := 0;
         Format  : Interfaces.C.Unsigned := 0;
         Width   : Integer               := 0;
         Text    : Lptstr                := null;
         Textmax : Integer               := 0;
         Subitem : Integer               := 0;
         Image   : Integer               := 0;
         Order   : Integer               := 0;
      end record;

   type Lvcolumn_Pointer is access all lvcolumn;

   type Drawitem is
      record
         CtlType       : Interfaces.C.Unsigned := 0;
         CtlID         : Interfaces.C.Unsigned := 0;
         CtlItemID     : Interfaces.C.Unsigned := 0;
         CtlItemAction : Interfaces.C.Unsigned := 0;
         CtlItemState  : Interfaces.C.Unsigned := 0;
         HwndItem      : Interfaces.C.Long := 0;
         Hdc           : Interfaces.C.Long := 0;
         RcItem        : Gwindows.Types.Rectangle_Type;
         ItemData      : System.Address;
      end record;

   type drawitem_Pointer is access all drawitem;

   -----------------
   -- body spec's --
   -----------------

   function lparam_To_drawitem_Pointer is
      new Unchecked_Conversion(Interfaces.C.Int,
                               Drawitem_Pointer);

   function Message_To_Nmlvcustomdraw_Pointer is
      new Unchecked_Conversion(Gwindows.Base.Pointer_To_Notification,
                               Pointer_To_Nmlvcustomdraw_Type);

   function Message_To_Nmlistview_Pointer is
      new Unchecked_Conversion(Gwindows.Base.Pointer_To_Notification,
                               Pointer_To_Nmlistview_Type);

   procedure SetTextColor(hDC    : Interfaces.C.long;
                          clrref : GWindows.Colors.Color_Type);
   pragma Import (StdCall, SetTextColor, "SetTextColor");

   procedure SetBkColor(hDC    : Interfaces.C.long;
                        clrref : GWindows.Colors.Color_Type);
   pragma Import (StdCall, SetBkColor, "SetBkColor");

   function Get_Lparam (Control   : in     Ex_List_View_Control_Type;
                        Index     : in     Natural;
                        Sub_Index : in     Natural                    )
                       return System.address;

   procedure Do_On_Redraw_Items (Lvcd_Ptr     : in     Pointer_To_Nmlvcustomdraw_Type;
                                 Control      : in out Ex_List_View_Control_Type;
                                 Return_Value : in out Interfaces.C.Long               );

   function Compare (Lparam1    : in     System.Address;
                     Lparam2    : in     System.Address;
                     Lparamsort : in     Sort_Data_Type    )
                    return Interfaces.C.Int;
   pragma Export (Stdcall, Compare, "compare");

   function Compare_two (Lparam1    : in     System.address;
                         Lparam2    : in     System.address;
                         Lparamsort : in     Sort_Data_Type    )
                        return Interfaces.C.Int;
   pragma Export (Stdcall, Compare_two, "compare_two");

   procedure Free is new Ada.Unchecked_Deallocation(Extended_Data_Array_Type,
                                                    Extended_Data_Array_Access);

   procedure Prepare_Header_Item_For_color(Control : in out Ex_List_View_Control_Type;
                                           Column  : in     Integer);

   function Convert_Date(Date: in Gstring) return Gstring;

   --------------
   -- createEx --
   --------------

   procedure CreateEx (
         Control    : in out Ex_List_View_Control_Type;
         Parent     : in out Gwindows.Base.Base_Window_Type'Class;
         Left       : in     Integer;
         Top        : in     Integer;
         Width      : in     Integer;
         Height     : in     Integer;
         Label_Editing : in  Boolean                              := False;
         NocolumnHeader  : in Boolean                            := False;
         Color_Mode : in     Boolean                              := True;
         Selection  : in     List_View_Control_Select_Type        := Single;
         View       : in     List_View_Control_View_Type          := List_View;
         Sort       : in     List_View_Control_Sort_Type          := No_Sorting;
         Arrange    : in     Boolean                              := True;
         Align      : in     List_View_Control_Alignment_Type     := Align_Left;
         Show       : in     Boolean                              := True;
         Is_Dynamic : in     Boolean                              := False       ) is
      use type Interfaces.C.Unsigned;

      Lvs_Icon      : constant := 16#0000#;
      Lvs_Report    : constant := 16#0001#;
      Lvs_Smallicon : constant := 16#0002#;
      Lvs_List      : constant := 16#0003#;
      --  LVS_TYPEMASK            : constant := 16#0003#;
      Lvs_Singlesel : constant := 16#0004#;
      LVS_SHOWSELALWAYS       : constant := 16#0008#;
      Lvs_Sortascending  : constant := 16#0010#;
      Lvs_Sortdescending : constant := 16#0020#;
      --  LVS_SHAREIMAGELISTS     : constant := 16#0040#;
      --  LVS_NOLABELWRAP         : constant := 16#0080#;
      Lvs_Autoarrange : constant := 16#0100#;
      LVS_EDITLABELS          : constant := 16#0200#;
      --  LVS_NOSCROLL            : constant := 16#2000#;
      --  LVS_TYPESTYLEMASK       : constant := 16#Fc00#;
      Lvs_Aligntop  : constant := 16#0000#;
      Lvs_Alignleft : constant := 16#0800#;
      --  LVS_ALIGNMASK           : constant := 16#0c00#;
      LVS_NOCOLUMNHEADER      : constant := 16#4000#;
      Lvs_Nosortheader : constant := 16#8000#;
      --  LVS_Ownerdrawfixed           : constant := 16#0400#;

      Styles : Interfaces.C.Unsigned := Lvs_ShowSelalways;
   begin
      if Selection = Single then
         Styles := Styles or Lvs_Singlesel;
      end if;

      case View is
         when Icon_View =>
            Styles := Styles or Lvs_Icon;
         when Small_Icon_View =>
            Styles := Styles or Lvs_Smallicon;
         when List_View =>
            Styles := Styles or Lvs_List;
         when Report_View =>
            Styles := Styles or Lvs_Report ;
      end case;

      if Sort /= Sort_Custom then
         Styles := Styles or Lvs_Nosortheader;
      else
         if Sort = Sort_Ascending then
            Styles := Styles or Lvs_Sortascending;
         elsif Sort = Sort_Descending then
            Styles := Styles or Lvs_Sortdescending;
         end if;
      end if;

      if Arrange then
         Styles := Styles or Lvs_Autoarrange;
      end if;

      if Label_Editing then
         Styles := Styles or LVS_EDITLABELS;
      end if;

      if Align = Align_Left then
         Styles := Styles or Lvs_Alignleft;
      elsif Align = Align_Top then
         Styles := Styles or Lvs_Aligntop;
      end if;

      if NoColumnheader then
         Styles := Styles or Lvs_Nocolumnheader;
      end if;

      Control.Color_Mode := Color_Mode;

      Create_Control (Control, Parent,
         "SysListView32",
         "",
         Left, Top, Width, Height,
         10, Styles,
         Is_Dynamic => Is_Dynamic);

      if Show then
         Gwindows.Common_Controls.Show (Common_Control_Type(Control));
      end if;

   end CreateEx;

   --------------------------
   -- set_extended_style --
   --------------------------

   procedure Set_Extended_Style (
         Control : in     Ex_List_View_Control_Type;
         Style   : in     List_View_Extended_Style_Type ) is
      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setextendedlistviewstyle;
            Wparam : Integer;
            Lparam : Integer                                            );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      case Style is
         when Grid =>
            Sendmessage(
               Wparam => Lvs_Ex_Gridlines,
               Lparam => Lvs_Ex_Gridlines);
         when Flatsb =>
            Sendmessage(
               Wparam => Lvs_Ex_Flatsb,
               Lparam => Lvs_Ex_Flatsb);
         when Headerdragdrop =>
            Sendmessage(
               Wparam => Lvs_Ex_Headerdragdrop,
               Lparam => Lvs_Ex_Headerdragdrop);
         when Fullrowselect =>
            Sendmessage(
               Wparam => Lvs_Ex_Fullrowselect,
               Lparam => Lvs_Ex_Fullrowselect);
      end case;
   end Set_Extended_Style;

   --------------------------
   -- remove_extended_style --
   --------------------------

   procedure Remove_Extended_Style (
         Control : in     Ex_List_View_Control_Type;
         Style   : in     List_View_Extended_Style_Type ) is
      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setextendedlistviewstyle;
            Wparam : Integer;
            Lparam : Integer           := 0                             );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      case Style is
         when Grid =>
            Sendmessage(Wparam => Lvs_Ex_Gridlines);
         when Flatsb =>
            Sendmessage(Wparam => Lvs_Ex_Flatsb);
         when Headerdragdrop =>
            Sendmessage(Wparam => Lvs_Ex_Headerdragdrop);
         when Fullrowselect =>
            Sendmessage(Wparam => Lvs_Ex_Fullrowselect);
      end case;
   end Remove_Extended_Style;

   --------------------------
   -- clear_extended_style --
   --------------------------

   procedure Clear_Extended_Styles (
         Control : in     Ex_List_View_Control_Type ) is
      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setextendedlistviewstyle;
            Wparam : Integer           := 0;
            Lparam : Integer           := 0                             );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end;

   -----------------
   -- insert_item --
   -----------------

   procedure Insert_Item (
                          Control : in out Ex_List_View_Control_Type;
                          Text    : in     Gstring;
                          Index   : in     Integer;
                          Icon    : in     Integer                   := 0 ) is

      C_Text : Gstring_C := Gwindows.Gstrings.To_Gstring_C (Text);
      Item : Lvitem;

      procedure Sendmessagea (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Insertitema;
            Wparam : Integer           := 0;
            Lparam : Lvitem            := Item              );
      pragma Import (Stdcall, Sendmessagea,
         "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessagew (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Insertitemw;
            Wparam : Integer           := 0;
            Lparam : Lvitem            := Item              );
      pragma Import (Stdcall, Sendmessagew,
         "SendMessage" & Character_Mode_Identifier);

      use Interfaces.C;
      Array_Access: Extended_Data_Array_access;
   begin
      Item.Mask := Lvif_Text or Lvif_Image or Lvif_Param;
      Item.Item := Index;
      Item.Image := Icon;
      Item.Text  := C_Text (0)'Unchecked_Access;

      Array_Access := new Extended_Data_Array_Type(0..Control.Column_Count-1);
      Item.Lparam := Address_Conversion.To_Address(Array_access);

      if Character_Mode = Unicode then
         Sendmessagew;
      else
         Sendmessagea;
      end if;

   exception
      when others =>
         null;
   end Insert_Item;

   -----------------
   -- delete_Item --
   -----------------

   procedure Delete_Item (Control : in out Ex_List_View_Control_Type;
                          Index   : in     Integer)is
      Lparam: System.Address;
      Array_Access: Extended_Data_Array_Access;
   begin
      Lparam := Get_Lparam(Control, Index, 0);
      Array_Access := Address_Conversion.To_Pointer(Lparam);
      Delete_Item(List_View_Control_Type(Control), Index);
      Free(Array_Access);
   end Delete_Item;

   procedure Delete_column (Control : in out Ex_List_View_Control_Type;
                            column   : in     Integer) is

      procedure Sendmessage(Hwnd   : Interfaces.C.Long := Handle (Control);
                            Umsg   : Interfaces.C.Int  := Lvm_deletecolumn;
                            Wparam : Interfaces.C.int  := Interfaces.C.Int(Column);
                            Lparam : Interfaces.C.int  := 0              );
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end Delete_Column;

   ------------------
   -- Set_Sub_Item --
   ------------------

   procedure Set_Sub_Item (
         Control   : in out Ex_List_View_Control_Type;
         Text      : in     Gstring;
         Index     : in     Integer;
         Sub_Index : in     Integer                    ) is
      C_Text : Gstring_C := Gwindows.Gstrings.To_Gstring_C (Text);

      Item : Lvitem;

      procedure Sendmessagea (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setitema;
            Wparam : Integer           := 0;
            Lparam : Lvitem            := Item              );
      pragma Import (Stdcall, Sendmessagea,
         "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessagew (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setitemw;
            Wparam : Integer           := 0;
            Lparam : Lvitem            := Item              );
      pragma Import (Stdcall, Sendmessagew,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Item.Mask := Lvif_Text;
      Item.Item := Index;
      Item.Subitem := Sub_Index;
      Item.Text := C_Text (0)'Unchecked_Access;

      if Character_Mode = Unicode then
         Sendmessagew;
      else
         Sendmessagea;
      end if;

   exception
      when others =>
         null;
   end Set_Sub_Item;

   --------------------
   -- set_image_list---
   --------------------

   procedure Set_Image_List (
         Control    : in     Ex_List_View_Control_Type;
         Image_List : in     Ex_Image_List_Type            ) is


      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Setimagelist;
            Wparam : Integer           := Lvsil_Small;
            Lparam : Interfaces.C.Long := Handle (Image_List) );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end Set_Image_List;

   ---------------------------
   -- set_header_image_list --
   ---------------------------

   procedure Set_Header_Image_List (Control    : in     Ex_List_View_Control_Type;
                                    Image_List : in     Ex_Image_List_Type            )is

      function Sendmessage_setimagelist (Hwnd   : Interfaces.C.Long;
                                         Umsg   : Interfaces.C.Int  := hdm_Setimagelist;
                                         Wparam : Interfaces.C.int  := 0;
                                         Lparam : Interfaces.C.Long := Handle (Image_List) )
                                        return Interfaces.C.Int;

      pragma Import (Stdcall, Sendmessage_setimagelist,
                       "SendMessage" & Character_Mode_Identifier);
      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      Header_Handle: Gwindows.Types.Handle;
      Ret: Interfaces.C.Int;
   begin
      Header_Handle := Sendmessage_Getheader;
      Ret := Sendmessage_Setimagelist(Hwnd => Header_Handle);

end Set_Header_Image_List;

   ------------------------
   -- clear_header_image --
   ------------------------

   procedure Clear_Header_Image(Control : in out Ex_List_View_Control_Type;
                                Column: in Integer)is


      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemA(Hwnd   : Interfaces.C.Long := 0;
                                       Umsg   : Interfaces.C.Int  := HDM_SETITEMA;
                                       Wparam : Integer := 0;
                                       Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      use Interfaces.C;

      Header_Handle: Gwindows.Types.Handle;
      Header_Item_ptr  : Hditem_Pointer := new hditem;
   begin
      -- get header
      Header_handle := Sendmessage_Getheader;

      -- get item data
      if Character_Mode = Unicode then
         Sendmessage_Hdmgetitemw(Hwnd => Header_Handle,
                                 Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmgetitema(Hwnd => Header_Handle,
                                 Wparam => Column,
                                 Lparam => Header_Item_ptr);
         end if;

      -- reset header image
      Header_Item_Ptr.Mask := HDI_FORMAT;
      Header_Item_Ptr.fmt := HDF_STRING + HDF_OWNERDRAW;


      if Character_Mode = Unicode then
         Sendmessage_Hdmsetitemw(Hwnd => Header_Handle,
                                 Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmsetitema(Hwnd => Header_Handle,
                                 Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

   end Clear_Header_Image;

   ----------------------
   -- set_header_image --
   ----------------------

   procedure Set_Header_image(Control : in out Ex_List_View_Control_Type;
                              Column: in Integer;
                              Image_Index: in integer) is

      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemA(Hwnd   : Interfaces.C.Long := 0;
                                       Umsg   : Interfaces.C.Int  := HDM_SETITEMA;
                                       Wparam : Integer := 0;
                                       Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      use Interfaces.C;

      Header_Handle: Gwindows.Types.Handle;
      Header_Item_ptr  : Hditem_Pointer := new hditem;
   begin
      -- get header
      Header_handle := Sendmessage_Getheader;

      -- get item data
      if Character_Mode = Unicode then
         Sendmessage_Hdmgetitemw(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmgetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

      -- set image
      Header_Item_Ptr.Mask := HDI_FORMAT + HDI_IMAGE;
      Header_Item_Ptr.Fmt := HDF_STRING + HDF_IMAGE + HDF_BITMAP_ON_RIGHT + HDF_OWNERDRAW;

      Header_Item_Ptr.IImage := Interfaces.C.Int(Image_Index);

      if Character_Mode = Unicode then
         Sendmessage_Hdmsetitemw(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmsetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

   end Set_Header_Image;

   -----------------------------------
   -- prepare_header_item_for_color --
   -----------------------------------

   procedure prepare_Header_Item_For_color(Control : in out Ex_List_View_Control_Type;
                                           Column: in integer) is

      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      use Interfaces.C;

      Header_Handle: Gwindows.Types.Handle :=0;
      Header_Item_ptr  : Hditem_Pointer := new hditem;
      Header_Color : Header_Item_Color_Access;
   begin
      -- get header
      Header_Handle := Sendmessage_Getheader;

      -- get item data
      if Character_Mode = Unicode then
        Sendmessage_Hdmgetitemw(Hwnd => Header_Handle, Wparam => Column,
                                Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmgetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

      Header_Item_Ptr.Mask := HDI_FORMAT + HDI_LPARAM;
      Header_Item_Ptr.Fmt := HDF_OWNERDRAW + HDF_STRING;

      -- build and assign color_type
      Header_Color := new Header_Item_Color_Type;
      Header_Item_Ptr.Lparam := Header_Item_Address_Conversion.To_Address(Header_color);

      if Character_Mode = Unicode then
         sendmessage_Hdmsetitemw(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmsetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

   end prepare_Header_Item_For_color;

   ----------------------
   -- set_header_color --
   ----------------------

   procedure Set_Header_Color(Control : in out Ex_List_View_Control_Type;
                              Column  : in     Integer;
                              Text_Color: in Color_Type;
                              Back_Color: in Color_type)is

      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_SETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmsetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemA(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemW(Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );
      pragma Import (Stdcall, Sendmessage_hdmgetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      Header_Handle: Gwindows.Types.Handle :=0;
      Header_Item_ptr  : Hditem_Pointer := new hditem;
      Header_Color : Header_Item_Color_Access;
   begin
      -- get header
      Header_Handle := Sendmessage_Getheader;

      -- get item data
      Header_Item_Ptr.Mask := HDI_LPARAM;

      if Character_Mode = Unicode then
        Sendmessage_Hdmgetitemw(Hwnd => Header_Handle, Wparam => Column,
                                Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmgetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

      Header_Color := Header_Item_Address_Conversion.To_pointer(Header_Item_Ptr.lparam);

      Header_Color.Text_Color := Text_Color;
      Header_Color.back_Color := back_Color;

      -- restore item
      Header_Item_Ptr.Mask := HDI_LPARAM;

      if Character_Mode = Unicode then
         sendmessage_Hdmsetitemw(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      else
         Sendmessage_hdmsetitema(Hwnd => Header_Handle, Wparam => Column,
                                 Lparam => Header_Item_ptr);
      end if;

   end Set_Header_Color;

   -----------------
   -- sort_column --
   -----------------

   procedure Sort_Column (Control : in out Ex_List_View_Control_Type;
                          Column  : in     Integer;
                          Sort : in Sort_Direction_Type := Auto;
                          Is_Date : in Boolean := False;
                          Up_Sort_Icon : in Integer := 0;
                          Down_Sort_Icon : in Integer := 1)is

      use Interfaces.C;
      procedure Sendmessage (Hwnd   : Interfaces.C.Long := Handle (Control);
                             Umsg   : Interfaces.C.Int  := Lvm_Sortitems;
                             Wparam : Sort_Data_Type;
                             Lparam : System.Address                         );

      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (Control);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;

      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemA(
                                       Hwnd   : Interfaces.C.Long := 0;
                                       Umsg   : Interfaces.C.Int  := HDM_SETITEMA;
                                       Wparam : Integer := 0;
                                       Lparam : Hditem_pointer := null            );

      pragma Import (Stdcall, Sendmessage_hdmsetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmsetitemW(
                                       Hwnd   : Interfaces.C.Long := 0;
                                       Umsg   : Interfaces.C.Int  := HDM_SETITEMW;
                                       Wparam : Integer := 0;
                                       Lparam : Hditem_pointer := null            );

      pragma Import (Stdcall, Sendmessage_hdmsetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemA(
                                        Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMA;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );

      pragma Import (Stdcall, Sendmessage_hdmgetitemA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessage_HdmgetitemW(
                                        Hwnd   : Interfaces.C.Long := 0;
                                        Umsg   : Interfaces.C.Int  := HDM_GETITEMW;
                                        Wparam : Integer := 0;
                                        Lparam : Hditem_pointer := null            );

      pragma Import (Stdcall, Sendmessage_hdmgetitemW,
                       "SendMessage" & Character_Mode_Identifier);

      Sort_Data : Sort_Data_Type := (Control_Handle => Handle (Control),
                                     First_Column => Column,
                                     First_Sort_Factor => 0,
                                     First_Is_Date => Is_date,
                                     Second_Column => -1,
                                     Second_Sort_Factor => 0,
                                     Second_Is_Date => false) ;
   begin

      -- remove old sort image
      Clear_Header_Image(Control, Control.Sorting.First_Sort_column);

      case Sort is
         when Auto =>
            -- choose sorting automatically
            if Column = control.Sorting.First_Sort_Column and
              control.Sorting.First_Column_Sort_Direction = Up then
               Control.Sorting.First_Column_Sort_Direction := Down;
               Sort_Data.First_Sort_Factor := -1;
            else
               control.Sorting.First_Column_Sort_Direction := up;
               control.Sorting.First_Sort_Column := Column;
               Sort_Data.First_Sort_Factor := 1;
            end if;
         when Up =>
            control.Sorting.First_Column_Sort_Direction := up;
            control.Sorting.First_Sort_Column := Column;
            Sort_Data.First_Sort_Factor := 1;
         when Down =>
            control.Sorting.First_Column_Sort_Direction := down;
            control.Sorting.First_Sort_Column := Column;
            Sort_Data.First_sort_Factor := -1;
      end case;

      -- sort with callback-function
      Sendmessage(Wparam => Sort_Data,
                  Lparam => Compare'Address);

      -- set new sort image
      if Control.Sorting.First_Column_Sort_Direction = up then
         Set_Header_Image(Control, Column, Up_Sort_Icon);
      else
         Set_Header_Image(Control, Column, down_Sort_Icon);
      end if;

   end Sort_Column;

   ---------------------
   -- sort_two_column --
   ---------------------

   procedure Sort_Two_Column (Control : in out Ex_List_View_Control_Type;
                              First_Column  : in     Integer;
                              First_Sort : in Limited_Sort_Direction_Type := up;
                              First_Is_Date: in Boolean := False;
                              second_Column  : in     Integer;
                              second_Sort : in Limited_Sort_Direction_Type := up;
                              second_Is_Date: in Boolean := False;
                              First_Up_Sort_Icon : in Integer := 0;
                              First_Down_Sort_Icon : in Integer := 1;
                              second_Up_Sort_Icon : in Integer := 2;
                              second_Down_Sort_Icon : in Integer := 3)is

      procedure Sendmessage (Hwnd   : Interfaces.C.Long := Handle (Control);
                             Umsg   : Interfaces.C.Int  := Lvm_Sortitems;
                             Wparam : Sort_Data_Type;
                             Lparam : System.Address                         );
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

      Sort_Data : Sort_Data_Type := (Control_Handle => Handle (Control),
                                     First_Column => First_Column,
                                     First_Sort_Factor => 0,
                                     First_Is_Date => First_Is_date,
                                     Second_Column => Second_Column,
                                     Second_Sort_Factor => 0,
                                     Second_Is_Date => Second_Is_date);
   begin
      Control.Sorting.First_Sort_Column := First_Column;
      Control.Sorting.First_Column_Sort_direction := First_sort;
      Control.Sorting.second_Sort_Column := second_Column;
      Control.Sorting.second_Column_Sort_direction := second_sort;

      if first_Sort = Up then
         Sort_Data.First_Sort_Factor := 1;
      else
         Sort_Data.First_Sort_Factor := -1;
      end if;

      if Second_Sort = Up then
         Sort_Data.second_Sort_Factor := 1;
      else
         Sort_Data.second_Sort_Factor := -1;
      end if;

      -- sort with callback-function
      Sendmessage(Wparam => Sort_Data,
                  Lparam => Compare_two'Address);

   end Sort_Two_Column;

   ---------------------
   -- get_sort_column --
   ---------------------

   procedure Get_Sort_Column(Control: in Ex_List_View_Control_Type;
                             First_Column: out Integer;
                             Second_Column: out Integer)is
   begin
      First_Column := Control.Sorting.First_Sort_Column;
      second_Column := Control.Sorting.second_Sort_Column;
   end Get_Sort_Column;

   --------------------------
   -- set_text_color --
   --------------------------

   procedure Set_Text_Color (
         Control : in     Ex_List_View_Control_Type;
         Color   : in     Color_Type                 ) is
      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Settextcolor;
            Wparam : Interfaces.C.Int  := 0;
            Lparam : Color_Type        := Color             );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end Set_Text_Color;

   --------------------------
   -- set_TextBk_color --
   --------------------------

   procedure Set_TextBk_Color (
         Control : in  out  Ex_List_View_Control_Type;
         Color   : in     Color_Type                 ) is
      procedure Sendmessage (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_SettextBkcolor;
            Wparam : Interfaces.C.Int  := 0;
            Lparam : Color_Type        := Color             );

      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
      Redraw(control);
   end Set_TextBk_Color;

   --------------------------
   -- set_Back_color --
   --------------------------

   procedure Set_Back_Color (
                             Control : in  out  Ex_List_View_Control_Type;
                             Color   : in     Color_Type                 ) is
      procedure Sendmessage (
                             Hwnd   : Interfaces.C.Long := Handle (Control);
                             Umsg   : Interfaces.C.Int  := Lvm_SetBkcolor;
                             Wparam : Interfaces.C.Int  := 0;
            Lparam : Color_Type        := Color             );

      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
      Redraw(control);
   end Set_Back_Color;

   --------------------------
   -- set_Item_color --
   --------------------------

   procedure Set_Item_Color (Control    : in out Ex_List_View_Control_Type;
                             Text_Color : in     Color_Type;
                             Bk_Color   : in     Color_Type;
                             Index      : in     Integer;
                             Sub_Index  : in     Integer                    ) is

      procedure Sendmessage (
                             Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Redrawitems;
            Wparam : Interfaces.C.Int  := Interfaces.C.Int (Index);
            Lparam : Interfaces.C.Int  := Interfaces.C.Int (Index)  );
      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);

      Array_access : Extended_Data_Array_access;
   begin
      Array_access := Address_Conversion.To_Pointer(Get_Lparam(Control, index, 0));
      Array_Access(Sub_Index).Text_Color := Text_Color;
      Array_Access(Sub_Index).back_Color := bk_Color;

      -- redraw items
      Sendmessage;

   exception
      when others =>
         null;
   end Set_Item_Color;

   -----------------------------------
   -- set_alternate_back_Item_color --
   -----------------------------------

   procedure Set_Alternate_Back_Item_Color (Control    : in out Ex_List_View_Control_Type;
                                       Bk_Color   : in     Color_Type;
                                       Index      : in     Integer;
                                       Sub_Index  : in     Integer                   ) is
      procedure Sendmessage (Hwnd   : Interfaces.C.Long := Handle (Control);
                             Umsg   : Interfaces.C.Int  := Lvm_Redrawitems;
                             Wparam : Interfaces.C.Int  := Interfaces.C.Int (Index);
                             Lparam : Interfaces.C.Int  := Interfaces.C.Int (Index)  );
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

      Array_access : Extended_Data_Array_access;
   begin
      Array_access := Address_Conversion.To_Pointer(Get_Lparam(Control, index, 0));
      Array_Access(Sub_Index).Alternate_Back_Color := bk_Color;

      -- redraw items
      Sendmessage;

   exception
      when others =>
         null;
   end Set_Alternate_Back_Item_Color;

   --------------------
   -- column_autosize--
   --------------------

   procedure Use_Alternate_Coloring(Control    : in out Ex_List_View_Control_Type;
                                    Coloring:  in Boolean := True) is
   begin
      Control.Use_Alternate_Coloring := Coloring;
   end Use_Alternate_Coloring;

   --------------------
   -- column_autosize--
   --------------------

   procedure Column_Autosize(Control: in Ex_List_View_Control_Type;
                             Column : in Integer )is

      use Interfaces.C;

      LVSCW_AUTOSIZE            : constant := -1;
      LVSCW_AUTOSIZE_USEHEADER  : constant := -2;

      procedure Sendmessage (
                             Hwnd   : Interfaces.C.Long := Handle (Control);
                             Umsg   : Interfaces.C.Int  := Lvm_SETCOLUMNWIDTH;
                             Wparam : Interfaces.C.Int := Interfaces.C.int(Column);
                             Lparam : Interfaces.C.Int := Lvscw_Autosize_useheader);
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end Column_Autosize;

   ----------------------
   -- Item_at_position --
   ----------------------

   procedure Item_At_Position (Control  : in Ex_List_View_Control_Type;
                               Position : in     Gwindows.Types.Point_Type;
                               Item     : in out Integer;
                               Subitem  : in out Integer                    ) is

      use Gwindows.Types;

      type Lvhittestinfo is
         record
            Pt      : Gwindows.Types.Point_Type := Position;
            Flags   : Natural                   := 0;
            Item    : Integer                   := 0;
            Subitem : Integer                   := 0;
         end record;

      Lvm_Subitemhittest : constant := Lvm_First + 57;

      procedure Sendmessage (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                             Umsg: Interfaces.C.Int := Lvm_Subitemhittest;
                             Wparam: Interfaces.C.Long := 0;
                             Lparam: in out Lvhittestinfo);
      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);

      Hittestinfo : Lvhittestinfo;
   begin
      Sendmessage(Lparam => Hittestinfo);

      Item := Hittestinfo.Item;
      Subitem := Hittestinfo.Subitem;
   end Item_At_Position;

   ----------------------
   -- get_subitem_rect --
   ----------------------

   function Get_Subitem_Rect(Control  : in Ex_List_View_Control_Type;
                             Item     : in Integer;
                             Subitem  : in Integer) return Gwindows.Types.Rectangle_Type is
      Rect: Gwindows.Types.Rectangle_Type;

      procedure Sendmessage (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                             Umsg: Interfaces.C.Int := LVM_GETSUBITEMRECT;
                             Wparam: Interfaces.C.Int := Interfaces.C.Int(Item);
                             Lparam: System.address := Rect'address);
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

      LVIR_BOUNDS       : constant := 0;
   begin
      Rect.Top := Subitem;
      Rect.Left := LVIR_BOUNDS;

      Sendmessage;

      return Rect;
   end Get_Subitem_Rect;

   ---------------------
   -- set_columnorder --
   ---------------------

   procedure Set_Columnorder(Control: in Ex_List_View_Control_Type;
                             Columnorder: in Int_Array_Type)is

      procedure Sendmessage (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                             Umsg: Interfaces.C.Int := LVM_SETCOLUMNORDERARRAY;
                             Wparam: Interfaces.C.Int := Interfaces.C.Int(Columnorder'last);
                             Lparam: System.address := Columnorder'Address);
      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end Set_Columnorder;

   ---------------------
   -- get_columnorder --
   ---------------------

   procedure get_Columnorder(Control: in Ex_List_View_Control_Type;
                             Columnorder: in out Int_Array_Type)is

      procedure Sendmessage (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                             Umsg: Interfaces.C.Int := LVM_GETCOLUMNORDERARRAY;
                             Wparam: Interfaces.C.Int := Interfaces.C.Int(Columnorder'last);
                             Lparam: System.address := Columnorder'Address);
      pragma Import (Stdcall, Sendmessage,
         "SendMessage" & Character_Mode_Identifier);
   begin
      Sendmessage;
   end get_Columnorder;

   -------------------
   -- insert_column --
   -------------------

   procedure Insert_Column (Control : in out Ex_List_View_Control_Type;
                            Text    : in     GString;
                            Index   : in     Integer;
                            Width   : in     Integer)is
   begin
      Control.Column_Count := Control.Column_Count + 1;
      Insert_Column(List_View_Control_Type(Control),Text, Index, Width);
      Prepare_Header_Item_For_color(Control, Index);
   end Insert_Column;

   ----------------------
   -- get_column_count --
   ----------------------

   function Get_Column_Count(Control : in Ex_List_View_Control_Type) return Integer is
   begin
      return Control.Column_Count;
   end Get_Column_Count;

   ---------------------
   -- get_column_text --
   ---------------------

   function Get_Column_Text(Control: in Ex_List_View_Control_Type;
                            Column: in Integer) return Gstring is

      use Interfaces.C;

      procedure SendmessageA (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                              Umsg: Interfaces.C.Int  := LVM_GETCOLUMNA;
                              Wparam: Interfaces.C.Int:= Interfaces.C.Int(Column);
                              Lparam: System.address);
      pragma Import (Stdcall, SendmessageA,
                       "SendMessage" & Character_Mode_Identifier);

      procedure SendmessageW (Hwnd: Interfaces.C.Long := Handle(List_View_Control_Type(Control));
                              Umsg: Interfaces.C.Int  := LVM_GETCOLUMNW;
                              Wparam: Interfaces.C.Int:= Interfaces.C.Int(Column);
                              Lparam: System.address);
      pragma Import (Stdcall, SendmessageW,
                       "SendMessage" & Character_Mode_Identifier);

      Max_Text : constant := 255;
      type Buffer is new Gstring_C
            (0 .. Max_Text);
      type Pbuffer is access all Buffer;

      function To_Pbuffer is
      new Ada.Unchecked_Conversion (Lptstr, Pbuffer);

      C_Text : Buffer;
      Lv: LvColumn;
   begin
      Lv.Mask := Lvcf_Text;
      Lv.Text := C_Text (0)'Unchecked_Access;
      Lv.Textmax := Max_Text;

      if Character_Mode = Unicode then
         Sendmessagew(Lparam => Lv'Address);
      else
         Sendmessagea(Lparam => Lv'Address);
      end if;

      return Gwindows.Gstrings.To_Gstring_From_C
        (Gstring_C (To_Pbuffer (Lv.Text).all));
   end Get_Column_Text;

   ---------------------
   -- get-column-width--
   ---------------------

   function Get_Column_Width(Control: in Ex_List_View_Control_Type;
                             Column: in Integer) return Integer is

      function Sendmessage(Hwnd: Interfaces.C.Long  := Handle(List_View_Control_Type(Control));
                           Umsg: Interfaces.C.Int   := LVM_GETCOLUMNWIDTH;
                           Wparam: Interfaces.C.Int := Interfaces.C.Int(Column);
                           Lparam: Interfaces.C.Int := 0) return Interfaces.C.Int;
      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

   begin
      return Integer(Sendmessage);
   end Get_Column_Width;



   --------------------
   -- event-handling --
   --------------------

   --------------------
   -- on_Header_click--
   --------------------

   procedure On_Header_Click (
         Control : in out Ex_List_View_Control_Type;
         Column  : in     Integer                    ) is
   begin
      Fire_On_Header_Click (Control, Column);
   end On_Header_Click;

   -----------------------------
   -- On_Header_Click_Handler --
   -----------------------------

   procedure On_Header_Click_Handler (
         Control : in out Ex_List_View_Control_Type;
         Handler : in     Header_Click_Event         ) is
   begin
      Control.On_Header_Click_Event := Handler;
   end On_Header_Click_Handler;

   --------------------------
   -- Fire_On_Header_Click --
   --------------------------

   procedure Fire_On_Header_Click (
         Control : in out Ex_List_View_Control_Type;
         Column  : in     Integer                    ) is
   begin
      if Control.On_Header_Click_Event /= null then
         Control.On_Header_Click_Event (Control, Column);
      end if;
   end Fire_On_Header_Click;

   --------------------
   -- on_Item_changed--
   --------------------
   procedure On_Item_changed (Control : in out Ex_List_View_Control_Type;
                               index  : in     Integer                    )is
   begin
      Fire_On_Item_changed (Control, index);
   end On_Item_Changed;

   -----------------------------
   -- on_Item_Changed_handler--
   -----------------------------

   procedure On_Item_Changed_Handler (Control : in out Ex_List_View_Control_Type;
                                       Handler : in     Item_Changed_Event         )is
   begin
      Control.On_Item_Changed_Event := Handler;
   end On_Item_Changed_Handler;

   --------------------------
   -- fire_on_item_changed --
   --------------------------

   procedure Fire_On_Item_changed (Control : in out Ex_List_View_Control_Type;
                                    index  : in     Integer                    )is
   begin
      if Control.On_Item_changed_Event /= null then
         Control.On_Item_changed_Event (Control, index);
      end if;
      end Fire_On_Item_Changed;

   ---------------
   -- On_Create --
   ---------------

   procedure On_Create (
         Control : in out Ex_List_View_Control_Type ) is
   begin
      Border (Control);
      Tab_Stop (Control);
   end On_Create;

   ---------------
   -- On_Notify --
   ---------------

   procedure On_Notify (
         Window       : in out Ex_List_View_Control_Type;
         Message      : in     Gwindows.Base.Pointer_To_Notification;
         Control      : in     Gwindows.Base.Pointer_To_Base_Window_Class;
         Return_Value : in out Interfaces.C.Long                           ) is

      use Interfaces.C;

      pragma Warnings (Off, Control);
      pragma Warnings (Off, Return_Value);

      Nm_Header_Click : constant := - 108;
      Nm_Customdraw   : constant := - 12;
      Nm_Item_Changed : constant := -101;

   begin
      case Message.Code is
         when Nm_Header_Click =>
            declare
               Nmlistview_Pointer : Pointer_To_Nmlistview_Type :=
                 Message_To_Nmlistview_Pointer(Message);
            begin
               On_Header_Click (Ex_List_View_Control_Type'Class (Window),
                  Integer(Nmlistview_Pointer.Isubitem));
            end;
         when Nm_Customdraw =>
            if Window.Color_Mode  then
               declare
                  Lvcd_Ptr : Pointer_To_Nmlvcustomdraw_Type :=
                    Message_To_Nmlvcustomdraw_Pointer (Message);
               begin
                  Do_On_Redraw_Items(Lvcd_Ptr, Window, Return_Value);
               end;
            end if;
         when Nm_Item_Changed =>
            declare
               Nmlistview_Pointer : Pointer_To_Nmlistview_Type :=
                 Message_To_Nmlistview_Pointer(Message);
            begin
               On_Item_changed(Ex_List_View_Control_Type'Class (Window),
                               Integer(Nmlistview_Pointer.Iitem));
            end;

         when others =>

            On_Notify(List_View_Control_Type(Window), Message, Control, Return_Value);
      end case;

   end On_Notify;


   ------------------------------------------------------------------------------
   -- body-functions
   ------------------------------------------------------------------------------

   ------------------
   -- get_lparam --
   ------------------

   function Get_Lparam (
         Control   : in     Ex_List_View_Control_Type;
         Index     : in     Natural;
         Sub_Index : in     Natural                    )
                       return System.address is

      Item : Lvitem;

      procedure Sendmessagea (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Getitema;
            Wparam : Integer           := 0;
            Lparam : System.Address    := Item'Address      );
      pragma Import (Stdcall, Sendmessagea,
         "SendMessage" & Character_Mode_Identifier);

      procedure Sendmessagew (
            Hwnd   : Interfaces.C.Long := Handle (Control);
            Umsg   : Interfaces.C.Int  := Lvm_Getitemw;
            Wparam : Integer           := 0;
            Lparam : System.Address    := Item'Address      );
      pragma Import (Stdcall, Sendmessagew,
         "SendMessage" & Character_Mode_Identifier);

   begin
      Item.Mask := Lvif_Param;
      Item.Item := Index;
      Item.Subitem := Sub_Index;
      if Character_Mode = Unicode then
         Sendmessagew;
      else
         Sendmessagea;
      end if;

      return Item.Lparam;
   end Get_Lparam;

   -----------------------------
   -- do_on_redraw_items --
   -----------------------------

   procedure Do_On_Redraw_Items (
         Lvcd_Ptr     : in     Pointer_To_Nmlvcustomdraw_Type;
         Control      : in out Ex_List_View_Control_Type;
         Return_Value : in out Interfaces.C.Long               ) is
      use Interfaces.C;
   begin
      -- set color in redraw according to color_mode
      case Lvcd_Ptr.Nmcd.Dwdrawstage is
         when Cdds_Prepaint =>
               Return_Value := Cdrf_Notifyitemdraw;
         when Interfaces.C.Long(Cdds_Itemprepaint) =>
               Return_Value := Cdrf_Notifysubitemdraw;
         when Interfaces.C.Long(Cdds_Itemprepaint + Cdds_Subitem) =>
            declare
               Array_Access: Extended_Data_Array_Access;
            begin
               Array_Access :=
                 Address_Conversion.To_Pointer(Get_Lparam(Control,
                                                          Integer(Lvcd_Ptr.Nmcd.Dwitemspec), 0));
               Lvcd_Ptr.Clrtext := Array_Access(Integer(Lvcd_Ptr.Isubitem)).Text_Color;
               if Control.Use_Alternate_Coloring then
                  if integer(Lvcd_Ptr.Nmcd.Dwitemspec) mod 2 = 0 then
                     Lvcd_Ptr.Clrtextbk := Array_Access(Integer(Lvcd_Ptr.Isubitem)).back_Color;
                  else
                     Lvcd_Ptr.Clrtextbk :=
                       Array_Access(Integer(Lvcd_Ptr.Isubitem)).Alternate_Back_Color;
                  end if;
               else
                  Lvcd_Ptr.Clrtextbk := Array_Access(Integer(Lvcd_Ptr.Isubitem)).back_Color;
               end if;
            end;
               Return_Value := Cdrf_Newfont;
         when others =>
            Lvcd_Ptr.Clrtextbk := To_Color(255,0,0);
            Return_Value := Cdrf_Newfont;
      end case;
   end Do_On_Redraw_Items;

   -------------
   -- compare --
   -------------

   function Compare (Lparam1    : in     System.address;
                     Lparam2    : in     System.address;
                     Lparamsort : in     Sort_Data_Type    )
     return Interfaces.C.Int is

      function Sendmessagea (Hwnd   : Interfaces.C.Long := 0;
                             Umsg   : Interfaces.C.Int  := Lvm_Finditema;
                             Wparam : Integer           := - 1;
                             Lparam : System.Address                      )
                            return Interfaces.C.Int;

      pragma Import (Stdcall, Sendmessagea,
                       "SendMessage" & Character_Mode_Identifier);

      function Sendmessagew (Hwnd   : Interfaces.C.Long := 0;
                             Umsg   : Interfaces.C.Int  := Lvm_Finditemw;
                             Wparam : Integer           := - 1;
                             Lparam : System.Address                      )
                            return Interfaces.C.Int;

      pragma Import (Stdcall, Sendmessagew,
                       "SendMessage" & Character_Mode_Identifier);

      Findinfo  : Findinfo_Type;
      Indexa,
      Indexb    : Integer;
      Class_Ptr : Pointer_To_Base_Window_Class;
   begin
      -- get index
      if Character_Mode = Unicode then
         Findinfo.Lparam := Lparam1;
         Indexa := Integer(Sendmessagew(Hwnd => Lparamsort.Control_Handle,
               Lparam => Findinfo'Address));
         Findinfo.Lparam := Lparam2;
         Indexb := Integer(Sendmessagew(Hwnd => Lparamsort.Control_Handle,
               Lparam => Findinfo'Address));
      else
         Findinfo.Lparam := Lparam1;
         Indexa := Integer(Sendmessagea(Hwnd => Lparamsort.Control_Handle,
               Lparam => Findinfo'Address));
         Findinfo.Lparam := Lparam2;
         Indexb := Integer(Sendmessagea(Hwnd => Lparamsort.Control_Handle,
               Lparam => Findinfo'Address));
      end if;

      Class_Ptr := Window_From_Handle(Lparamsort.Control_Handle);
      if Lparamsort.First_Is_Date then
         declare
            Texta : Gstring := Convert_Date(Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                                  Indexa, Lparamsort.First_Column));
            Textb : Gstring := Convert_Date(Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                                  Indexb, Lparamsort.First_Column));
         begin
            -- comparision
            if Texta = Textb then
               return Interfaces.C.Int(0);
            end if;
            if Texta < Textb then
               return Interfaces.C.Int(-1 * Lparamsort.First_Sort_Factor);
            else
               return Interfaces.C.Int(1 * Lparamsort.First_Sort_Factor);
            end if;
         end;
      else
         declare
            Texta : Gstring := Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                     Indexa, Lparamsort.First_Column);
            Textb : Gstring := Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                     Indexb, Lparamsort.First_Column);
         begin

            -- comparision
            if Texta = Textb then
               return Interfaces.C.Int(0);
            end if;
            if Texta < Textb then
               return Interfaces.C.Int(-1 * Lparamsort.First_Sort_Factor);
            else
               return Interfaces.C.Int(1 * Lparamsort.First_Sort_Factor);
            end if;
         end;
      end if;
   end Compare;

   -----------------
   -- compare_two --
   -----------------

   function Compare_two (Lparam1    : in     System.address;
                         Lparam2    : in     System.address;
                         Lparamsort : in     Sort_Data_Type    )
                        return Interfaces.C.Int is

      use system;
      use Interfaces.C;

      function Sendmessagea (Hwnd   : Interfaces.C.Long := 0;
                             Umsg   : Interfaces.C.Int  := Lvm_Finditema;
                             Wparam : Integer           := - 1;
                             Lparam : System.Address                      )
                            return Interfaces.C.Int;

      pragma Import (Stdcall, Sendmessagea,
                       "SendMessage" & Character_Mode_Identifier);

      function Sendmessagew (Hwnd   : Interfaces.C.Long := 0;
                             Umsg   : Interfaces.C.Int  := Lvm_Finditemw;
                             Wparam : Integer           := - 1;
                             Lparam : System.Address                      )
                            return Interfaces.C.Int;

      pragma Import (Stdcall, Sendmessagew,
                       "SendMessage" & Character_Mode_Identifier);

      Findinfo  : Findinfo_Type;
      Indexa,
      Indexb    : Integer;
      Class_Ptr : Pointer_To_Base_Window_Class;
      Compare_Value: Interfaces.C.int;

   begin
      Compare_Value := Compare(Lparam1, Lparam2, Lparamsort);

      if Compare_Value = 0 then
         -- compare 2nd column
         -- get index
         if Character_Mode = Unicode then
            Findinfo.Lparam := Lparam1;
            Indexa := Integer(Sendmessagew(Hwnd => Lparamsort.Control_Handle,
                                           Lparam => Findinfo'Address));
            Findinfo.Lparam := Lparam2;
            Indexb := Integer(Sendmessagew(Hwnd => Lparamsort.Control_Handle,
                                           Lparam => Findinfo'Address));
         else
            Findinfo.Lparam := Lparam1;
            Indexa := Integer(Sendmessagea(Hwnd => Lparamsort.Control_Handle,
                                           Lparam => Findinfo'Address));
            Findinfo.Lparam := Lparam2;
            Indexb := Integer(Sendmessagea(Hwnd => Lparamsort.Control_Handle,
                                           Lparam => Findinfo'Address));
         end if;

         Class_Ptr := Window_From_Handle(Lparamsort.Control_Handle);

         if Lparamsort.Second_Is_Date then
            declare
               Texta : Gstring := Convert_Date(Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                                     Indexa, Lparamsort.second_Column));
               Textb : Gstring := Convert_Date(Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                                     Indexb, Lparamsort.second_Column));
            begin

               -- comparision
               if Texta = Textb then
                  return Interfaces.C.Int(0);
               end if;
               if Texta < Textb then
                  return Interfaces.C.Int(-1 * Lparamsort.second_Sort_Factor);
               else
                  return Interfaces.C.Int(1 * Lparamsort.second_Sort_Factor);
               end if;
            end;
         else
            declare
               Texta : Gstring := Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                        Indexa, Lparamsort.second_Column);
               Textb : Gstring := Text (Ex_List_View_Control_Type (Class_Ptr.All),
                                        Indexb, Lparamsort.second_Column);
            begin

               -- comparision
               if Texta = Textb then
                  return Interfaces.C.Int(0);
               end if;
               if Texta < Textb then
                  return Interfaces.C.Int(-1 * Lparamsort.second_Sort_Factor);
               else
                  return Interfaces.C.Int(1 * Lparamsort.second_Sort_Factor);
               end if;
            end;
         end if;
      else
         return Compare_value;
      end if;

   end Compare_Two;

   ----------------
   -- on_destroy --
   ----------------

   procedure On_Destroy (Window : in out Ex_List_View_Control_Type)is
      Array_Access: Extended_Data_Array_Access;
   begin
      for I in 0..Item_Count(window)-1 loop
         Array_Access := Address_Conversion.To_Pointer(Get_Lparam(window, I, 0));
         Free(Array_Access);
      end loop;
      On_Destroy(List_View_Control_Type(Window));
   end On_Destroy;

   ----------------
   -- on_message --
   ----------------

   procedure On_Message
     (Window       : in out Ex_List_View_Control_Type;
      message      : in     Interfaces.C.unsigned;
      wParam       : in     Interfaces.C.int;
      lParam       : in     Interfaces.C.int;
      Return_Value : in out Interfaces.C.long)is

      use Gwindows.Windows;
      use Interfaces.C;

      WM_KEYDOWN                 : constant := 256;
      WM_KEYUP                   : constant := 257;
      WM_DRAWITEM                : constant := 16#002B#;
      ODT_HEADER                 : constant := 100;

      WM_HSCROLL                 : constant := 16#114#;

      Header_Handle: Gwindows.Types.Handle;
      Draw_Item: Drawitem_Pointer;
      Header_Color: Header_Item_Color_Access;

      function Sendmessage_Getheader (Hwnd   : Interfaces.C.Long := Handle (window);
                                      Umsg   : Interfaces.C.Int  := LVM_GETHEADER;
                                      Wparam : Integer := 0;
                                      Lparam : Integer := 0                        )
                                     return Interfaces.C.Long;
      pragma Import (Stdcall, Sendmessage_getheader,
                       "SendMessage" & Character_Mode_Identifier);

   begin
      case message is
         when WM_HSCROLL =>
            On_Message(List_View_Control_Type(Window),Message,Wparam, Lparam, Return_Value);
            declare
               Parent_window: Pointer_To_Base_Window_Class;
            begin
               Parent_window := Parent(Window);
               On_Message(Parent_Window.all, Message, Wparam, Lparam, Return_Value);
              end;
         when WM_KEYDOWN =>
            declare
               Parent_window: Pointer_To_Base_Window_Class;
              begin
                 Parent_window := Parent(Window);
                 On_Message(Parent_Window.all, Message, Wparam, Lparam, Return_Value);
              end;
         when WM_KEYUP =>
            declare
               Parent_window: Pointer_To_Base_Window_Class;
            begin
               Parent_window := Parent(Window);
                 On_Message(Parent_Window.all, Message, Wparam, Lparam, Return_Value);
            end;
         when WM_DRAWITEM =>
            -- get header
            Header_Handle := Sendmessage_Getheader;
            Draw_Item := Lparam_To_Drawitem_pointer(Lparam);
            if Draw_Item.Ctltype = ODT_HEADER then
               Header_Color := Header_Item_Address_Conversion.To_Pointer(Draw_Item.itemdata);
               Settextcolor(Draw_Item.Hdc, Header_Color.Text_Color);
               Setbkcolor(Draw_Item.Hdc, Header_Color.back_Color);
            end if;
         when others =>
            null;
      end case;
      On_Message(List_View_Control_Type(Window),Message,Wparam, Lparam, Return_Value);
   end On_Message;

   procedure Get_Approximate_View (List   : in     Ex_List_View_Control_Type;
                                   Items  : in     Integer                   := -1;
                                   Width  :    out Integer;
                                   Height :    out integer) is
   --

      use Gwindows.Utilities;
      use Interfaces.C;
      function Sendmessage (Hwnd   : Interfaces.C.Long := Handle (list);
                            Umsg   : Interfaces.C.Int  := Lvm_approximateviewrect;
                            Wparam : Interfaces.C.Int  := Interfaces.C.Int(Items);
                            Lparam : Interfaces.c.int                                )
                           return Interfaces.C.int;

      pragma Import (Stdcall, Sendmessage,
                       "SendMessage" & Character_Mode_Identifier);

      Result: Interfaces.C.int;
   begin
      Result := Sendmessage(Lparam => Interfaces.c.int(Make_Long(-1,-1)));
      Width := Integer(Unsigned_Low_Word(Result));
      height := Integer(Unsigned_High_Word(Result));
   end Get_Approximate_View;
   ----------------------------------------------------------------------------------------
      procedure Get_Scroll_Info(List: in Ex_List_View_Control_Type;
                             Scroll_Direction: in Direction_Type;
                             Scroll_Min: out Integer;
                             Scroll_Max: out Integer;
                             Scroll_Pos: out Integer;
                             Scroll_Page: out Integer;
                             Scroll_Track_pos: out Integer) is
      use Interfaces.C;
      function GetScrollInfo(Hwnd: C.Long;
                               FnBar: C.Int;
                               Lpsi: System.Address) return C.int;
      pragma Import (Stdcall, Getscrollinfo, "GetScrollInfo");
      SB_HORZ  : constant := 0;
      SB_VERT  : constant := 1;
      SB_CTL  : constant := 2;
      SB_BOTH  : constant := 3;
      SIF_RANGE : constant := 16#1#;
      SIF_PAGE : Constant := 16#2#;
      SIF_POS : Constant := 16#4#;
      SIF_DISABLENOSCROLL : constant := 16#8#;
      SIF_TRACKPOS : constant := 16#10#;
      SIF_ALL : constant := SIF_RANGE + SIF_PAGE + SIF_POS + SIF_TRACKPOS;

      Sci: Scrollinfo_Type;
      Result: C.Int;
   begin
      Sci.Cbsize := Sci'Size / 8;
      Sci.Fmask := Sif_All;

      if Scroll_Direction = Hor then
         Result := Getscrollinfo(Handle(List), Sb_Horz, Sci'Address);
      else
         Result := Getscrollinfo(Handle(List), Sb_vert, Sci'Address);
      end if;

      Scroll_Min := Integer(Sci.Nmin);
      Scroll_Max := Integer(Sci.Nmax);
      Scroll_Pos := Integer(Sci.Npos);
      Scroll_Page := Integer(Sci.Npage);
      Scroll_Track_Pos := Integer(Sci.Ntrackpos);

   end Get_Scroll_Info;
   ----------------------------------------------------------------------------------------
   procedure Init_Date_format(Format: in String) is
      use Ada.Strings.Fixed;
      Arr_Pos: Natural := 1;
   begin
      -- reset array
      for I in Date_Convert.arr'Range loop
         Date_Convert.arr(I).first := 0;
         Date_Convert.arr(I).Last := 0;
      end loop;
      -- YYYY
      Date_Convert.Arr(Arr_pos).first := Index(Format, "YYYY");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 3;
         Arr_Pos := Arr_Pos + 1;
      end if;
      -- MM
      Date_Convert.Arr(Arr_pos).first := Index(Format, "MM");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 1;
         Arr_Pos := Arr_Pos + 1;
      end if;
      -- DD
      Date_Convert.Arr(Arr_pos).first := Index(Format, "DD");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 1;
         Arr_Pos := Arr_Pos + 1;
      end if;
      -- hh
      Date_Convert.Arr(Arr_pos).first := Index(Format, "hh");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 1;
         Arr_Pos := Arr_Pos + 1;
      end if;
      -- mi
      Date_Convert.Arr(Arr_pos).first := Index(Format, "mi");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 1;
         Arr_Pos := Arr_Pos + 1;
      end if;
      -- ss
      Date_Convert.Arr(Arr_pos).first := Index(Format, "ss");
      if Date_Convert.Arr(Arr_pos).first > 0 then -- when found
         Date_Convert.Arr(Arr_pos).Last := Date_Convert.Arr(Arr_pos).First + 1;
         Arr_Pos := Arr_Pos + 1;
      end if;
      Date_Convert.Is_valid := True;
   exception
      when others =>
         Date_Convert.Is_valid := false;
         raise;
   end Init_Date_format;
   ----------------------------------------------------------------------------------------
   function Convert_Date(Date: in Gstring) return Gstring is
      Return_String: gString(1..20);
      Pos: Natural:= 1;
      Offset: NaTural;
   begin
      if Date_Convert.Is_Valid = False then
         Init_Date_format(Default_Date_Format);
      end if;

      for I in Date_Convert.arr'Range loop
         if Date_Convert.arr(I).last > 0 then
            Offset := Date_Convert.Arr(I).Last - Date_Convert.Arr(I).First;
            Return_String(Pos..Pos + offset) :=
              Date(Date_Convert.arr(I).First..Date_Convert.arr(I).Last);

            Pos := Pos + Offset + 1;
         else
            return Return_String(1..Pos-1);
         end if;
      end loop;

      return Return_String(1..Pos-1);

   exception
      when E:others =>
         return "xxxx";
   end Convert_Date;
end Gwindows.Common_Controls.Ex_LV;
