with Ada.Text_Io; use Ada.Text_Io;
with Gwindows.Types; use Gwindows.Types;
with Gwindows.Base; use Gwindows.Base;
with Interfaces.C;

package body Gwindows.Common_Controls.Ex_Tab is

   procedure On_Message(Window       : in out Ex_Tab_control_Type;
                        message      : in     Interfaces.C.unsigned;
                        wParam       : in     Interfaces.C.int;
                        lParam       : in     Interfaces.C.int;
                        Return_Value : in out Interfaces.C.long) is

      use Interfaces.C;

      WM_ERASEBKGND              : constant := 20;
      Area   : Rectangle_Type := (Top => 0, Left => 0,
                                  Bottom => Client_Area_Height(Window),
                                  Right => Client_Area_Width(Window));
      Control : Pointer_To_Base_Window_Class :=
        Window_From_Handle (long (lParam));
      Canvas : Canvas_Type;
   begin
      case Message is
         when WM_ERASEBKGND =>
            Handle (Window.Canvas, GWindows.Types.Handle (wParam));
                        Fill_Rectangle(Window.Canvas, Area, Window.Brush);
--            On_Message(Tab_Window_Control_Type(Window), Message, Wparam, Lparam, Return_Value);
         when others =>
            On_Message(Tab_Window_Control_Type(Window), Message, Wparam, Lparam, Return_Value);
      end case;
   end On_Message;

   procedure On_Create (Window : in out ex_tab_control_Type) is
   begin
      Window.Bk_Color := System_Color(COLOR_BTNFACE);
      Create_Solid_Brush(Window.Brush, Window.Bk_color);
      On_Create(Tab_Window_Control_type(Window));
   end On_Create;

   procedure Set_Bk_Color(Window: in out ex_tab_control_Type;
                          Color : in Color_type) is
   begin
      Window.Bk_Color := Color;
      Create_Solid_Brush(Window.Brush, Window.Bk_Color);
      Redraw(Window, True);
   end Set_Bk_Color;

   function Get_Bk_Color(Window: in ex_tab_control_Type) return Color_Type is
   begin
      return Window.Bk_Color;
   end Get_Bk_Color;

end Gwindows.Common_Controls.Ex_Tab;
