------------------------------------------------------------------------------
--                                                                          --
--                      gwindows.common_controls.ex_tab                     --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.3 $                              --
--                                                                          --
--                            Konad GmbH 2004                               --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. It is distributed in the hope that it will be useful,  but WITHOUT --
-- ANY WARRANTY;  without  even the  implied warranty of MERCHANTABILITY or --
-- FITNESS FOR A PARTICULAR PURPOSE.    See the GNU General  Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
-- More information about GWINDOWS and the most current public version can  --
-- be located on the web at http://www.gnavi.org/gwindows                   --
--                                                                          --
------------------------------------------------------------------------------
-- Features of Ex_Tab_Control_Type:
-- -> You may set and get a background color for an Ex_Tab_Control_Type.
-- -> That is the color of the top of the tab pages, not the contained
-- -> windows.
------------------------------------------------------------------------------

with Gwindows.Drawing; use Gwindows.Drawing;
with Gwindows.Drawing_objects; use Gwindows.Drawing_objects;
with Gwindows.Colors; use Gwindows.Colors;

package Gwindows.Common_Controls.Ex_Tab is

   type Ex_Tab_Control_Type is new Tab_Window_Control_Type with private;

   procedure Set_Bk_Color(Window: in out ex_tab_control_Type;
                          Color : in Color_type);

   function Get_Bk_Color(Window: in ex_tab_control_Type) return Color_Type;

   procedure On_Message(Window       : in out Ex_Tab_control_Type;
                        message      : in     Interfaces.C.unsigned;
                        wParam       : in     Interfaces.C.int;
                        lParam       : in     Interfaces.C.int;
                        Return_Value : in out Interfaces.C.long);

private
   procedure On_Create (Window : in out ex_tab_control_Type);

   type Ex_Tab_Control_Type is new Tab_Window_Control_Type with
      record
         Canvas : Canvas_Type;
         Brush  : Brush_Type;
         Bk_Color: Color_Type;
      end record;

end Gwindows.Common_Controls.Ex_Tab;
