package body Example_Pkg is

procedure Main is

   Main_Window: Ex_Main_Window_type;
   Toolbar: Ex_ToolBar_Control_Type;
   Il_Toolbar, Il_colors, Il_header: Ex_Image_List_Type;
   Split_Lr, Split_Tb: Splitbar_Type;
   Content_Window: Window_Type;
   Win_Left, Win_Right, Win_Top, Win_Bottom: Ex_Window_Type;
   Tree: Example_Tree_Type;
   Combo: Ex_Drop_Down_Combo_Box_Type;
   Label: Static_Controls.Label_Type;
   Bitmap: Bitmap_Type;
   Bitmap_play, Bitmap_Stop: Bitmap_Type;
   Bitmap_Dog1, Bitmap_Dog2, Bitmap_Mouse: Bitmap_Type;
   New_Node, Parent_node: Gwindows.Common_Controls.Tree_Item_Node;
   List: Ex_list_View_Control_Type;
   Button_play, Button_stop, Button_flash: extended_Button_Type;
   Font : Font_Type;

   -- body-specs
   procedure Set_Header_Color(List: in out Ex_List_View_Control_Type;
                              Index: in Integer := -1);
   --------------------------------------------------------------------------------------
   -- menu
   procedure Do_On_Menu_Select (Window : in out Gwindows.Base.Base_Window_Type'Class;
                                Item   : in     Integer                               ) is
   begin
      Message_Box("Message", "ID: " & To_Gstring_From_String(Integer'Image(Item)));
   end Do_On_Menu_Select;
   --------------------------------------------------------------------------------------
   -- sort columns
   procedure Do_On_Header_Click (Control : in out Ex_List_View_Control_Type;
                                 Column  : in     Integer                    ) is
   begin
      if Column = 0 then Return; end if;

      if Column = 3 then -- date-sorting
         Sort_Column(Control => Control, Column => Column, Is_Date => true);
      else
         Sort_Column(Control => Control, Column => Column, Is_Date => false);
      end if;
      Set_Header_Color(Control, Column);
   end Do_On_Header_Click;
   --------------------------------------------------------------------------------------
   -- fill listview
   procedure Insert_Listitem(List: in out Ex_List_View_Control_Type;
                             Index: in Integer;
                             Icon: in Integer;
                             First, Name, birth: in Gwindows.GString;
                             color: in Color_type)is
   begin
      Insert_Item(Control => List, Text => "", Index => Index, Icon => icon);
      Set_Sub_Item(Control => List, Text => first, Index => Index, Sub_index => 1);
      Set_Sub_Item(Control => List, Text => name, Index => Index, Sub_index => 2);
      Set_Sub_Item(Control => List, Text => birth, Index => Index, Sub_index => 3);
      -- colors
      for I in 1..Get_Column_Count(List)-1 loop
         Set_Item_Color(Control => List, Text_color => color, Bk_Color => White,
                        Index => Index, Sub_Index => i);
      end loop;
   end Insert_Listitem;
   --------------------------------------------------------------------------------------
   -- fill treeview
   procedure Insert_treeitem(tree: in out example_tree_type;
                             Parent_node: in Tree_Item_node;
                             new_node: in out Tree_Item_node;
                             Icon: in Integer;
                             Text: in Gwindows.GString;
                             color: in Color_Type;
                             Where : in Tree_View_List_Location_Type)is
   begin
      Insert_Item(Control => Tree, Text => text, Parent_node => parent_node,
                  New_Node => New_Node, where => where);
      Set_Image(Control => Tree, item => new_Node, Image_List_Index => icon);
      Set_Item_Id(Tree, New_Node, Icon);
      Set_Item_Color(Tree, color, White, New_Node);
   end Insert_treeitem;
   --------------------------------------------------------------------------------------
   procedure Do_On_Tree_change(Window    : in out Ex_Tree_View_Control_Type'Class;
                               Node : in Tree_Item_node)is

   begin
      case Get_Item_Id(Window, Node) is
         when 1 =>
            Set_Bk_Color(Window, To_Color(0,0,0));
         when 2 =>
            Set_Bk_Color(Window, To_Color(255,0,0));
         when 3 =>
            Set_Bk_Color(Window, To_Color(0,0,255));
         when 4 =>
            Set_Bk_Color(Window, To_Color(255,255,0));
         when 5 =>
            Set_Bk_Color(Window, To_Color(220,220,220));
         when 6 =>
            Set_Bk_Color(Window, To_Color(0,255,0));
         when others =>
            Set_Bk_Color(Window, To_Color(255,255,255));
      end case;
      Redraw(Window);
   end Do_On_Tree_Change;
   --------------------------------------------------------------------------------------
   -- button-click-handler
   procedure Do_On_Button_click(Window : in out GWindows.Base.Base_Window_Type'Class)is
      use Interfaces.C;
   begin
      if Handle(Extended_Button_Type(Window)) = Handle(Button_play) then
         Start_Flash(Button_flash);
      else
         Stop_Flash(Button_flash);
      end if;
   end Do_On_Button_Click;
   --------------------------------------------------------------------------------------
   procedure Set_Header_Color(List: in out Ex_List_View_Control_Type;
                              Index: in Integer := -1) is
      Default_Header_Color: Color_Type := System_Color(Color_BTNFACE);
   begin
      for I in 0..Get_Column_Count(List)-1 loop
         Set_Header_Color(Control => List, Column => I,
                          Text_Color => To_Color(0,0,0),
                          Back_Color => Default_Header_Color);
      end loop;

      if Index /= -1 then
         Set_Header_Color(Control => List, Column => index,
                          Text_Color => To_Color(255,255,0),
                          Back_Color => Default_Header_Color);
      end if;
   end Set_Header_Color;
   --------------------------------------------------------------------------------------
begin
   -- zentrale Fonts erzeugen
   Create_Stock_Font(Font, Gwindows.Drawing_Objects.Default_Gui);

   -- Main-window
   Create(Window => Main_Window, Title => "Example Gwindows_Extended", Left => 0, Top => 0,
          Width => 600, Height => 350);
   Keyboard_Support(Main_Window, True);
   Center(Main_Window);
   Set_Font(Main_Window, Font);

   -- Imagelists
   Create_From_File(List => Il_toolbar,
                    File_Name => "../resources/il_toolbar.bmp", Width => 16);
   Create_From_File(List => Il_colors,
                    File_Name => "../resources/il_colors.bmp", Width => 16);
   Create_From_File(List => Il_header,
                    File_Name => "../resources/il_header.bmp", Width => 16);

   -- Toolbar
   CreateEx(Control => Toolbar, Parent => Main_Window, Left => 0, Top => 0,
            Width => 200, Height => 25);
   Dock(Toolbar, Gwindows.Base.At_Top);
   Set_Image_List(Toolbar, Il_toolbar);
   on_button_select_handler(toolbar, Do_On_Menu_Select'unrestricted_access);

   -- toolbar-buttons
   Add_Button (Control => Toolbar, Image_Index => 1, Command => 101,
               Button_Style => No_Style, Text => "new", Tooltip => "new document");
   Add_Button (Control => Toolbar, Image_Index => 2, Command => 102,
               Button_Style => No_Style, Text => "open", Tooltip => "open document");
   Add_Button (Control => Toolbar, Image_Index => 3, Command => 103,
               Button_Style => No_Style, Text => "cut", Tooltip => "cut a part");
   Add_Separator(Control => Toolbar, Width => 20);
   Add_Button (Control => Toolbar, Image_Index => 4, Command => 104,
               Button_Style => check_Style, Text => "toggle", Tooltip => "toggle button");
   Add_Button (Control => Toolbar, Image_Index => 1, Command => 105,
               Button_Style => No_Style, Text => "just text",
               Tooltip => "button has no image", None_Image => True);

   -- activate toolbar-tooltips
   Activate_Tooltip(Main_Window, Toolbar);

   -- content-window
   Create_As_Control(Window => Content_Window, Parent => Main_Window, Title => "",
                     Left => 0, Top => 0, Height => 0, Width => 0);
   Dock(Content_Window, Gwindows.Base.Fill);

   -- windows
   Create_As_control(Window => Win_top, Parent => content_window, Left => 0, Top => 0,
                     Height => 100, Width => 0);
   Dock(Win_top, Gwindows.Base.At_top);

   Create_As_control(Window => Win_bottom, Parent => content_window, Left => 0, Top => 0,
                     Height => 100, Width => 0);
   Border(Win_bottom, True);
   Dock(Win_bottom, Gwindows.Base.At_bottom);
   -- set back-color
   Set_Bk_Color(Win_bottom, To_Color(255,255,220));

   Create_As_control(Window => Win_Left, Parent => Win_top, Left => 0, Top => 0,
                     Height => 0, Width => 100);
   Dock(Win_Left, Gwindows.Base.At_Left);

   Create_As_control(Window => Win_right, Parent => Win_top, Left => 0, Top => 0,
                     Height => 0, Width => 100);
   Dock(Win_right, Gwindows.Base.At_right);

   -- tree
   Createex(Control => Tree, Parent => Win_Left, Left => 0, Top => 0,
            Width => 0, Height => 0, Edit_labels => true);
   Dock(Tree, Gwindows.Base.Fill);
   Set_Image_List(tree, Il_colors);
   On_Change_Handler(Tree, Do_On_Tree_Change'Unrestricted_Access);

   -- inserting, setting image and color for node
   Insert_Treeitem(Tree => Tree, Parent_Node => 0, New_Node => Parent_Node,
                   Where => As_A_Root, Text => "Colors", Color => Black, Icon => 0);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "black", Color => Black, Icon => 1);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "red", Color => red, Icon => 2);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "blue", Color => Blue, Icon => 3);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "yellow", Color => yellow, Icon => 4);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "gray", Color => gray, Icon => 5);
   Insert_Treeitem(Tree => Tree, Parent_Node => Parent_node, New_Node => New_node,
                   Where => last, Text => "green", Color => green, Icon => 6);

   -- expand tree
   Expand(Control => Tree, At_Node => Parent_Node);

   -- list
   Createex(Control => list, Parent => Win_right, Left => 0, Top => 0,
            Width => 0, Height => 0, Label_Editing => True,
            View => Gwindows.Common_Controls.Report_View,
            Sort => Sort_custom);

   Dock(list, Gwindows.Base.Fill);
   On_Header_Click_Handler(List, Do_On_Header_Click'Unrestricted_Access);
   Set_Image_List(list, Il_colors);
   Set_Header_Image_List(list, Il_header);

   -- extended-styles
   Set_Extended_Style(Control => List, Style => Grid);
   Set_Extended_Style(Control => List, Style => headerdragdrop);
   Set_Extended_Style(Control => List, Style => fullrowselect);

   -- insert columns
   Insert_Column(Control => List, Text => "Icon", Index => 0, Width => 50);
   Insert_Column(Control => List, Text => "First", Index => 1, Width => 100);
   Insert_Column(Control => List, Text => "Name", Index => 2, Width => 100);
   Insert_Column(Control => List, Text => "Birth", Index => 3, Width => 100);

   -- set header-color
   Set_Header_Color(List);

   Init_Date_Format("DD.MM.YYYY");

   -- inserting, setting image and color for item
   Insert_Listitem(List, 0, 1, "Franz", "Mustermann", "10.05.1971", black);
   Insert_Listitem(List, 1, 2, "Max", "Mller", "25.12.1934", red);
   Insert_Listitem(List, 2, 3, "Heinz", "Schaller", "01.04.1981", blue);
   Insert_Listitem(List, 3, 4, "Renate", "Schmidt", "13.11.1965", yellow);
   Insert_Listitem(List, 4, 5, "Sren", "Neumann", "28.02.1956", gray);
   Insert_Listitem(List, 5, 6, "Thorben", "Blumberg", "04.06.1983", green);

   -- combo
   Create(Combo => Combo, Parent => Win_bottom, Text => "",
          Top => 20, Left => 30, Width => 130, Height => 200,
          Sort => false);
   Set_Selection_Field_Height (Combo, 18);
   declare
      Index: Integer;
   begin
      Add(Combo, "January", Index);
      Add(Combo, "February", Index);
      Add(Combo, "March", Index);
      Add(Combo, "April", Index);
      Add(Combo, "May", Index);
      Add(Combo, "June", Index);
      Add(Combo, "July", Index);
      Add(Combo, "August", Index);
      Add(Combo, "September", Index);
      Add(Combo, "October", Index);
      Add(Combo, "November", Index);
      Add(Combo, "December", Index);
   end;

   Set_Autocomplete(Combo, True);
   Force_Valid_Text(Combo, True);

   -- label
   Static_Controls.Create(Static => Label, Parent => Win_Bottom, Text => "",
                          Top => 50, Left => 30, Width => 130, Height => 20);

   -- Buttons
   Load_Bitmap(Bitmap_play, "#304", Transparent_Button);
   Create(Button => Button_play, Parent => Win_Bottom, Top => 20, Left => 300,
          Width => 30, Height => 30, Image => Bitmap_play);
   On_Click_Handler(Button_play, Do_On_Button_Click'Unrestricted_Access);
   Load_Bitmap(Bitmap_stop, "#305", Transparent_Button);
   Create(Button => Button_stop, Parent => Win_Bottom, Top => 20, Left => 360,
          Width => 30, Height => 30, Image => Bitmap_stop);
   On_Click_Handler(Button_stop, Do_On_Button_Click'Unrestricted_Access);
   Load_Bitmap(Bitmap_dog1, "#301", Transparent_Button);
   Load_Bitmap(Bitmap_dog2, "#302", Transparent_Button);
   Load_Bitmap(Bitmap_mouse, "#303", Transparent_Button);
   Create(Button => Button_Flash, Parent => Win_Bottom, Top => 20, Left => 440,
          Width => 30, Height => 30, Image => Bitmap_dog1);
   Init_Flash(Button_Flash, Silent_Image => Bitmap_Mouse,
              Activ_Image => Bitmap_Dog2);

   -- docking
   Dock_Children(Win_Left);
   Dock_Children(Win_right);
   Dock_Children(Win_Top);
   Dock_Children(Main_Window);

   --splitbars
   Create(Splitbar => Split_Lr, Parent => Window_Type(Win_Top),
          First_Window => Window_Type(Win_Left),
          Second_Window => Window_Type(Win_Right),
          Splitbar_Pos => 200, Width => 2,
          Refresh_At_End => True, Direction => Hor, Move_Line_Color => blue);
   Create(Splitbar => Split_tb, Parent => Window_Type(Content_Window),
          First_Window => Window_Type(Win_Top),
          Second_Window => Window_Type(Win_Bottom),
          Splitbar_Pos => 200, Width => 2,
          Refresh_At_End => false, Direction => Ver, Move_Line_Color => green);


   Visible(Main_Window);
   -- Message-Loop
   Gwindows.Application.Message_Loop;
end Main;
--------------------------------------------------------------------------------------
procedure On_Notify (Window       : in out example_Tree_Type;
                     Message      : in     Gwindows.Base.Pointer_To_Notification;
                     Control      : in     Gwindows.Base.Pointer_To_Base_Window_Class;
                     Return_Value : in out Interfaces.C.long)is

   TVN_FIRST              : constant := -400;
   TVN_BEGINLABELEDITA    : constant := TVN_FIRST-10;
   TVN_BEGINLABELEDITW    : constant := TVN_FIRST-59;
   TVN_ENDLABELEDITA      : constant := TVN_FIRST-11;
   TVN_ENDLABELEDITW      : constant := TVN_FIRST-60;
begin
   case Message.Code is
      when Tvn_Endlabeleditw | Tvn_Endlabeledita =>
         Return_Value := 1; -- changing of label-text ok
      when others =>
        On_Notify(Ex_Tree_View_Control_Type(Window), Message, Control, Return_Value);
   end case;
end On_Notify;

end Example_Pkg;
